package testobjectdb;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

abstract public class WithTransaction implements Runnable {

  abstract void body(EntityManager em);
  public void run() {
    EntityManagerFactory emf = Persistence.createEntityManagerFactory(Main.TMP_TEST_ODB);
    EntityManager em = emf.createEntityManager();

    em.getTransaction().begin();

    body(em);

    em.getTransaction().commit();
    
    em.close();
    emf.close();
   
  }
}